#    launch.py is part of Mediagrid by Luca Franceschini & Luca Carrubba.
#    For info: www.gemq.info
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

try:
	import os
        import glob
        import commands
	from subprocess import Popen,PIPE
	import platform
        import re
except:
	print "ERROR: You need os, subprocess, platform Python Libraries"

try:
	import pyext
except:
	print "ERROR: This script must be loaded by the PD/Max pyext external"

#class that format the textfile
class formattext(pyext._class):

	# number of inlets and outlets
	_inlets=2
	_outlets=1

	# methods for all inlets
	outs = []
	
	firstarg = []
	
	in_text = []
	id_text = 0
	
	# constructor
	def __init__(self,*args):
            #self.firstarg = args[0]
            print "Inizializzato oggetto formattext"

	def _anything_1(self,*args):
            self.in_text = os.path.abspath(str(args[0]))
            try:
                f = open(self.in_text, "r")
                try:
                    allfile = f.read()
                finally:
                    f.close()
            except IOError:
                pass

            plat={"Windows":"\r\n", 'Linux':"\n" } # add macos as well
            sistema = platform.system()
            out_path = "/tmp/"
            
            fullwords = re.findall(r'\w+', allfile)
            newname = "%s%s%d%s" % ("textplayer", "-", self.id_text, ".txt") 
            newfile = open(os.path.join(out_path, newname), 'w')
    
            for i in fullwords:
                newfile.write( i + plat[sistema] )

            self._outlet(1, os.path.join(out_path, newname))

	def int_2(self, f):
            self.id_text = int(f)
            output = self.id_text
            self._outlet(1, output)

#class that load fonts
class loadfonts(pyext._class):

	# number of inlets and outlets
	_inlets=1
	_outlets=1

	# methods for all inlets
	outs = []
	
	firstarg = []
	
	font_path = []
	
	# constructor
	def __init__(self,*args):
            #self.firstarg = args[0]
            print "Inizializzato oggetto loadfonts"

	def _anything_1(self,*args):
            self.font_path = os.path.abspath(str(args[0]))

            out_path = os.path.join(self.font_path, "fonts")
            plat={"Windows":"C:\Windows\Fonts", "Linux":"/usr/share/fonts" }
            sistema = platform.system()
            in_path = os.path.abspath(plat[sistema])

            if not os.path.exists(out_path):
                os.makedirs(out_path)
        
                #list all chars and create symb links
                for root, dirs, files in os.walk(in_path):
                    files = [ fi for fi in files if fi.endswith(".ttf") ]
                    for i in files:
                        char = os.path.join(root,i)
                        charlink = os.path.join(out_path, i)
                        if not os.path.exists(charlink):
                            os.symlink(char, charlink)
                            self._outlet(1, i)
            else:
                for root, dirs, files in os.walk(out_path):
                    files = [ fi for fi in files if fi.endswith(".ttf") ]
                    for i in files:
                        self._outlet(1, i)
                        

#class that detect cam devices
class loadcams(pyext._class):

	# number of inlets and outlets
	_inlets=1
	_outlets=1

	# methods for all inlets
	outs = []
	
	firstarg = []
	
	# constructor
	def __init__(self,*args):
            #self.firstarg = args[0]
            print "Inizializzato oggetto loadcams"

	def bang_1(self):
            sistema = platform.system()
            
            #linux system
            if sistema == "Linux":
                webcam = []
                com = "v4l-info "
                for element in glob.glob('/dev/video*'):
                    webcam.append(element)
                    webcam.reverse()
                for web in webcam:
                    name = commands.getoutput(com+web+' |grep card')
                    a,b = name.split('card')
                    cam = b.split(':')[1]
                    output = cam.split('"')[1]
                    self._outlet(1, output)
            #mac system
            elif sistema == "Darwin":
                print "no darwin support"
            #win32 system
            elif sistema == "Windows":
                print "no windows support"

